<?php
/**
 * @file
 */


/**
 * Admin settings callback
 */
function processing_admin_settings() {
  $form = array();

  $form['processing_js_path'] = array(
    '#type' => 'textfield',
    '#title' => t('Processing.js Path'),
    '#description' => t('Provide the relative path to processing.js that you downloaded from processingjs.org. This will usually be sites/all/libraries/processing.js/processing-VERSION.js'),
    '#default_value' => variable_get('processing_js_path', ''),
    '#element_validate' => array('processing_js_path_validate'),
  );

  $form['global_settings'] = array(
    '#type' => 'fieldset',
    '#title' => t('Global Settings'),
    '#collapsible' => TRUE,
    '#collpased' => TRUE,
  );

  $form['global_settings']['processing_render_mode_global'] = array(
    '#type' => 'radios',
    '#title' => t('Render Mode'),
    '#description' => t('Choose the behavior of the input filter. If Source first, source code will be displayed with a button to render. If Render first, processing will render on load, and a butto to display source code. If Render only, processing will always be rendering and there will be no UI to hide/view source.'),
    '#options' => array('source' => t('Source first'), 'render' => t('Render first'), 'only' => t('Render Only')),
    '#default_value' => variable_get('processing_render_mode_global', 'source'),
  );

  $form['global_settings']['processing_restricted_global'] = array(
    '#type' => 'textfield',
    '#title' => t('Restricted Code'),
    '#description' => t('List all functions, separated by spaces, that will <b>not</b> be allowed. Lines which contain these functions will be commented out to prevent syntax errors.'),
    '#default_value' => variable_get('processing_restricted_global', 'println print link status param'),
  );

  return system_settings_form($form);
}

/**
 * Processing js path validate callback.
 */
function processing_js_path_validate($element, &$form_state) {
  $path = $form_state['values']['processing_js_path'];

  if (!drupal_realpath($path)) {
    form_error($element, t('Could not verify the location of %path',  array('%path' => $path)));
  }
}
